//+------------------------------------------------------------------+
//|                                               ibplugin_test1.mq4 |
//|                              Copyright 2020, trade-commander.com |
//|                                 https://www. trade-commander.com |
//+------------------------------------------------------------------+

// -------------------------------------------------------------------
#property copyright "Copyright 2020, trade-commander.com"
#property link      "https://www. trade-commander.com"
#property version   "1.00"
#property strict

const int __tc_version=1;

#include <trade-commander/ibplugin/ibpluginif.mqh>
//#include <trade-commander/gui_objects.mqh>
//#include <trade-commander/ibplugin/ibplugin_eula.mqh>


//+------------------------------------------------------------------+
//| input parameters                                   |
//+------------------------------------------------------------------+

// IBKR contract parameter
input int         i_runs                            = 10;       // # test runs
input int         i_delay_ms                        = 0;        // Delay in ms between test runs
// [[ TWS / Gateway connection parameter                                                              
input string      i_ip                                = "";        // IP address of API (TWS/Gateway) (default: local host)
input int         i_port                              = 7496;      // Port of API (this number should be in the API settings of TWS / GW)
// ]] TWS / Gateway connection parameter


input int         i_loglevel                          = 3;         // Log Severity: 1=system...6=verbose.
                                                                   // Logfiles are stored in user/documents/trade-commander.com/ibplugin/host_applications/<this_app>/log


void ibplugin_test_run(int runs,int delay)
{
   // create config name from terminal name
    PrintFormat("%s ++ begin. runs=%d delay=%d",__FUNCTION__,runs,delay);
    const int connectionid=1;
    
    for(int i=0;i <  runs;++i)
    {
        
        int iret=ibgCONNECT (connectionid,i_ip,i_port, 77,2,25000);
        PrintFormat("connect status=%d",iret);
        
        Sleep(delay);
        iret=ibgDISCONNECT (connectionid);
        iret=ibgCONNECTION_STATUS(connectionid);
        PrintFormat("new connect status=%d",iret);        
    }
    PrintFormat("%s -- end.",__FUNCTION__);
}
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
    string config_name=StringFormat("mt_test_%s",TerminalName());
    int iret=ibgINIT_SCRIPT(config_name);
    // create config name from terminal name
    ibplugin_test_run(i_runs,i_delay_ms);
    
    return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
  
    ibgDEINIT_SCRIPT();
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
    
   
}
